###############################################################################
# Copyright (c) 2009, 2016, Oracle and/or its affiliates. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice (including the next
# paragraph) shall be included in all copies or substantial portions of the
# Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.
#

diff --git a/nls/en_US.UTF-8/XLC_LOCALE.pre b/nls/en_US.UTF-8/XLC_LOCALE.pre
index 35d009f..949a877 100644
--- a/nls/en_US.UTF-8/XLC_LOCALE.pre
+++ b/nls/en_US.UTF-8/XLC_LOCALE.pre
@@ -53,6 +53,7 @@
 		name	ISO8859-4:GR
 	}
 	font	{
+		load_option delay_nocheck
 		primary	ISO8859-4:GR
 	}
 }
@@ -116,6 +117,7 @@
 		name	ISO8859-15:GR
 	}
 	font	{
+		load_option delay_nocheck
 		primary	ISO8859-15:GR
 	}
 }
@@ -156,9 +158,70 @@
 		vertical_rotate	all
 	}
 }
+XCOMM  
+fs15   {
+       charset {
+               name    BIG5-0:GLGR
+       }
+       font    {
+               load_option     delay_nocheck
+               primary         BIG5-0:GLGR
+       }
+}
+XCOMM CTL language
+fs16   {
+       charset {
+               name    TIS620-0:GR
+       }
+       font    {
+               load_option     delay_nocheck
+               primary         TIS620-0:GR
+       }
+}
+XCOMM fs18 class (ISO8859-6) (Arabic)
+fs17   {
+       charset {        
+               name    ISO8859-6:GLGR
+       }
+       font    {
+               load_option     delay_nocheck
+               primary         ISO8859-6:GLGR
+       }    
+}
+XCOMM fs19 class (ISO8859-8) (Hebrew)
+fs18   {
+       charset {
+               name    ISO8859-8:GR
+       }
+       font    {
+               load_option     delay_nocheck
+               primary         ISO8859-8:GR
+       }
+}
+XCOMM fs20 class (SUN.UNICODE.INDIA-0) (Indian Script)
+fs19   {
+       charset {
+               name    SUN.UNICODE.INDIA-0:GLGR
+       }
+       font    {        
+               load_option     delay_nocheck
+               primary         SUN.UNICODE.INDIA-0:GLGR
+       }       
+}      
+XCOMM fs20 (Last, fallback) class (unicode-fontspecific)
+fs20   {
+       charset {
+               name    UNICODE-FONTSPECIFIC:GLGR
+       }       
+       font    {
+               load_option     delay_nocheck
+               primary         UNICODE-FONTSPECIFIC:GLGR
+       }       
+}      
+
 XCOMM	ISO10646 should come last so the fonts above will actually be used
-XCOMM	fs16 class
-fs16	{
+XCOMM	fs21 class
+fs21	{
 	charset	{
 		name	ISO10646-1
 	}
@@ -290,4 +353,52 @@
 	ct_encoding	ISO10646-1
 }
 
+XCOMM cs16 class
+cs16     {
+       side            GR:Default
+       length          2
+       ct_encoding     BIG5-0:GLGR
+}
+
+XCOMM Thai
+cs17     {
+       side            GR:Default
+       length          1
+       ct_encoding     TIS620-0:GR
+}
+
+XCOMM Ar
+cs18 { 
+       side            GR:Default
+       length          2
+       ct_encoding     ISO8859-6:GLGR
+}                      
+       
+XCOMM  cs19 class  He
+cs19   {
+       side            GR:Default
+       length          1
+       ct_encoding     ISO8859-8:GR
+}
+
+XCOMM   cs20 class      
+cs20    {
+       side            GR:Default
+       length          2
+       ct_encoding     SUN.UNICODE.INDIA-0:GLGR
+}
+
+XCOMM  Last, fallback class
+cs21   { 
+       side            GR:Default
+       length          1
+       ct_encoding     UNICODE-FONTSPECIFIC:GLGR
+}       
+
+XCOMM  cs22 class
+cs22   {
+        side            none
+        ct_encoding     ISO10646-1
+}      
+
 END XLC_XLOCALE
